module epsr_module

use ser1_module, only : ser1 

implicit none

private

public :: epsr

intrinsic real

integer, private, parameter :: real8  = selected_real_kind(10)

contains
 
      SUBROUTINE epsr(MMAX,NOR, KOL) 
      integer, intent(in) :: mmax
      integer, intent(in) :: nor
      integer, intent(in) :: kol 
 
      real(kind=real8), dimension(-1:10, 0:20) :: D
      real(kind=real8), dimension(0:70)        :: AL
      real(kind=real8), dimension(1:30)        :: C
      real(kind=real8)                         :: TERM, AUX0, AUX1, AUX2, X 

      integer :: ifang
      integer :: mmaxplus
      integer :: ma
      integer :: norplus
      integer :: lastmurs 
      integer :: mursmin
      integer :: murs 
      integer :: j
      integer :: jj 
      integer :: k 
      integer :: m
      real    :: EPSOO
!
      EPSOO=0.0 
      MMAXPLUS=MMAX+1
      NORPLUS=NOR+1
      LASTMURS=0 
      M=0
      CALL ser1(M, TERM) 
      AUX0=TERM 
      AUX1=AUX0+EPSOO 
      AUX0=1.0/AUX0
!
      DO 2 K=0, NOR 
      D(K,0)=EPSOO 
      AL(K)=AUX1
      D(K,1)=AL(K)
      AL(NORPLUS+K)=AUX0
    2 CONTINUE
!
      D(-1,0)=EPSOO
      D(-1,1)=AUX1
!
      DO 5 M=1, MMAX
      DO 6 K=0, NOR
      IF (K.EQ.0) GO TO 7
      JJ=2*(M/2) 
      IF (M.EQ.JJ) AUX1=AUX2
      AUX0=AUX1-AL(K) 
      GO TO 10 
    7 LASTMURS=(M+1)*NORPLUS-1
      CALL ser1(M, TERM) 
      AUX0=TERM 
      AUX1=AUX0+AL(0) 
      D(-1,M+1)=AUX1 
   10 CONTINUE 
      MURS=K 
      DO 11 J=0, M 
      IF (J.EQ.0) GO TO 12 
      AUX0=1.0/(AUX1-AL(MURS)) 
      GO TO 13 
   12 AUX0=1.0/AUX0
   13 CONTINUE 
      IF (J.EQ.0) GO TO 15 
      AUX0=AUX0+AL(MURSMIN)
   56 AL(MURSMIN)=AUX2 
   15 AUX2=AUX1 
      AUX1=AUX0
      MURSMIN=MURS 
      MURS=MURSMIN+NORPLUS 
   11 CONTINUE 
      AL(MURSMIN)=AUX2 
      AL(MURS)=AUX1
      JJ=2*(M/2) 
      IF (M.EQ.JJ) GO TO 31 
      D(K,M+1)=AUX1 
      GO TO 6 
   31 D(K,M+1)=AUX2 
    6 CONTINUE 
    5 CONTINUE 
      DO 35 IFANG=-1, NOR, KOL 
      DO 36 M=0, MMAXPLUS 
      MA=0 
      DO 37 K=IFANG, IFANG+KOL-1
      IF (K.GT.NOR) GO TO 37 
      MA=MA+1 
      C(MA)=D(K,M) 
   37 CONTINUE 
      print "(i5,10(tr2,f12.10))", m,(c(j), j=1, ma)
   36 CONTINUE
   35 Continue
 
   endsubroutine epsr 
!
!***********************************************************************
!
end module epsr_module
!
 
