module intphi_module

use trap_module, only : trap 
use f2_module  , only : f

implicit none

private

public :: intphi

integer, private, parameter :: real8  = selected_real_kind(10)

contains
 
!
!***********************************************************************
! subroutine for intphi-algorithm
!***********************************************************************
!
      subroutine intphi (sigma, mmax, kol,a,b) 
      real   , intent(in) :: sigma
      integer, intent(in) :: mmax
      integer, intent(in) :: kol
      real   , intent(in) :: a
      real   , intent(in) :: b

      real(kind=real8), dimension(0:50,0:50) :: al
      real(kind=real8), dimension(0:50)      :: c
!
      integer :: j
      integer :: k
      integer :: kk
      integer :: m
      integer :: ma
      integer :: mmaxplus

      !real(kind=real8) :: term
      real :: term
!
!
      al(0,0)=0.0

      do m=0, mmax 
        mmaxplus =mmax+1
        call trap(a,b,m, term,f) 
        al (m+1,0)=al(m,0)+term 
      enddo
!
      do k=1, mmaxplus 
        do m=0, mmaxplus-k 
          al(m,k)=((sigma+m+k)*al(m+1,k-1)-(sigma +m)*al(m,k-1))/k 
        enddo
      enddo
! 
      do kk=0, mmaxplus, kol 
        do m=0, mmaxplus-kk 
          ma=0 
          do k=kk, kk+kol-1 
            if (m<=mmaxplus-k) then
              ma=ma+1 
              c(ma)=al (m,k) 
            endif
          enddo
          print "(i5,10(tr2,f8.6))", m,(c(j), j=1, ma)
        enddo
      enddo
      
      endsubroutine intphi
!
end module intphi_module
!
 
