module trap_module

implicit none

public :: trap

contains

 
      subroutine trap(a, b, m, term,f) 

      real   , intent(in)    :: a
      real   , intent(in)    :: b 
      integer, intent(in)    :: m 
      real   , intent(inout) :: term

      interface
      function f(x) result(f_result)
      real, intent(in) :: x
      real             :: f_result
      endfunction f
      endinterface
!
      integer                :: nu
      real                   :: asum
!
      real   , save          :: epmean
      real   , save          :: range
      real   , save          :: tpz
      real   , save          :: pit
      real                   :: h
      real                   :: xx 
!
      if (m==0) then

        epmean = 0.5*(f(a)+f(b))
        range=b-a 
        tpz=range*epmean 
        pit=tpz 
        term = tpz
        return
      endif

      h    = range/real(m+1) 
      asum = epmean 
!
      do nu=1, m 
        xx   = a+nu*h 
        asum = asum+f(xx) 
      enddo
!
      asum = h*asum 
      tpz  = asum-pit 
      pit  = asum 
      term = tpz 

   endsubroutine trap 
!
!***********************************************************************
!
end module trap_module
!
