module romb_module

implicit none

public :: romb

integer, private, parameter :: real8 = selected_real_kind(10)

contains

      subroutine romb(a, b, m, term,f) 
!
      real   , intent(in)  :: a
      real   , intent(in)  :: b
      integer, intent(in)  :: m 
      real(kind=real8), intent(out) :: term

      interface
      function f(x) result(f_result)
      real, intent(in) :: x
      real             :: f_result
      endfunction f
      endinterface

      real, save    :: bean
      real, save    :: summ
      real, save    :: hm
      real, save    :: rbt
      real          :: hmplus
      real          :: xx
      real          :: sumint
   
      integer       :: ihp
      integer       :: nu


      if(m /= 0) then
        go to 110 
      endif

      bean = 0.5*(f(a)+f(b))
      summ = 0.0
      hm   = b-a 
      rbt  = hm*bean 
!
      go to 125 
!
110   ihp= (2**(m-1))-1 
!
      hmplus = 0.5*hm 
      xx     = a+hmplus 
      sumint = f(xx)
 
      if (m == 1) then
        go to 115 
      endif

      nu     = 1
111   xx     = xx+hm
      sumint = sumint+f(xx)
 
      if (nu >= ihp) then
        go to 115 
      endif

      continue 
      nu = nu+1

      go to 111 

115   rbt=hmplus*(sumint-summ-bean)

      summ = sumint+summ 
      hm   = hmplus
 
125   term = rbt

   endsubroutine romb 
!
!***********************************************************************
!
end module romb_module
!
