module inteul_module

use romb_module, only : romb
use f1_module  , only : f

implicit none

private

public :: inteul

intrinsic :: min

integer, private, parameter :: real8  = selected_real_kind(10)

contains
 
      SUBROUTINE inteul(Z, MMAX, COL,a,b) 
      real(kind=real8), intent(in) :: Z
      integer         , intent(in) :: mmax
      integer         , intent(in) :: COL
      real            , intent(in) :: a
      real            , intent(in) :: b 

      integer                      :: in 
      integer                      :: j
      integer                      :: k 
      integer                      :: LESSER 
      integer                      :: m
      integer                      :: n 
      integer                      :: ma
      integer                      :: nu 
      integer                      :: jj,kk,ll
      INTEGER                      :: R,RANFANG, DIM 
      real   , dimension(100)      :: S
      real   , dimension(20)       :: C
      real                         :: V, P, Q, ZPM 
      real                         :: TERM
!
      P=1.0/(1.0-Z) 
      Q=-Z*P 
!
      DO M=0, MMAX 
        CALL romb(a,b,M,TERM,f) 
        IF (M == 0) S(M+1)=TERM 
        IF (M /= 0) S(M+1)=S(M)+TERM 

        K    = MMAX+1+M+1
        S(K) = S(M)+P*TERM 
        DIM  = MMAX+1
!
        if(m >= 0)then
          DO R=1, M 
            KK    = M-R+(R+1)*DIM-((R+1)*(R+1-3))/2 
            JJ    = M-R+1+R*DIM-(R*(R-3))/2 
            LL    = M-R+R*DIM-(R*(R-3))/2 
            S(KK) = P*S(JJ)+Q*S(LL) 
          enddo
        endif

      enddo

      DO RANFANG=0, MMAX+1, COL 
        N=1
!
        DO M=N, MMAX+1-RANFANG 
          MA     = 0
          LESSER = min(M,COL-1)

          DO R=RANFANG, RANFANG+LESSER 
            MA    = MA+1 
            NU    = M-R+RANFANG 
            IN    = NU+R*DIM-(R*(R-3))/2 
            C(MA) = S(IN) 
          enddo

          print "(i5,10(tr2,f10.5))", m,(C(J), J=1, MA-1)

        enddo
      enddo
 
   endsubroutine inteul 
!
!***********************************************************************
!
end module inteul_module
!
