%  AdamsBashforth
% 	-----
%  This program illustrates the use of function AdamsBashforth for determining coefficients
%  in the explicit or implicit Adams-type formulas used for differential equation solution.
%  These integration formulas have the form
%
%   y_{n+1} = y_{n} + h*\sum(cof(j)*f(j))
%
%   where f(j) denotes the value of f for
%
%  x(j) = x_{n} + h*a(j)
%
%   The weighting coefficient cof(j) equals c(j,1)/c(j,2).
%
%   uses AdamsBashforth.m
%

fprintf('\n\n');
disp(['Adams Bashforth Integration Formulas']);
fprintf('\n');

fprintf(' order six explicit\n\n');
fprintf('           j        ctop          cbot \n');
disp([(0:-1:-5)', AdamsBashforth(0:-1:-5)]);

fprintf(' order six implicit\n\n');
fprintf('           j        ctop          cbot \n');
disp([(1:-1:-4)', AdamsBashforth(1:-1:-4)]);

fprintf('\n');

