function DiffTabl(X,Y)

% This function can be used to produce a difference table.
%  The input is two vectors X,Y of the same length.
%  X contains the domain points and Y contains the value at the X points. 
%
% USAGE: difftabl(X,Y) 
% sample input
%
% X = [0.0:0.25:1.00];
% Y = [1.0:2:10.0];
%
% difftabl(X,Y) produces difference table.
%

if (nargin<2 | nargin>2),
  help difftabl; return
end

N  = length(X); 
dy = zeros(N-1,N-1);

for i=1:N-1
   if i==1, for j=1:N-1
     dy(1,j)=Y(j+1)-Y(j);
     end
     dy(1,1:N-1)
   else  for j=1:N-i
     dy(i,j)=dy(i-1,j+1)-dy(i-1,j);
     end
     dy(i,1:N-i)
   end
end;

