function Y = fht(X)
%
%  Fast Hartley Transform
%
n  = length(X); 
n1 = n/2; 
Y  = zeros(size(X));

if n == 1
  Y(1) = X(1);
  return;
end

fp = X(1:2:n);
fi = X(2:2:n);

% use recursion 

fp = fht(fp); 
fi = fht(fi);

% component multiply 

m  = length(fi);
b  = [fi(1);fi(m:-1:2)];
a  = fi;
fi = a.*cos(pi*(0:m-1)'/m)+b.*sin(pi*(0:m-1)'/m);

% combine

Y(1:n1)     = fp + fi;
Y((n1+1):n) = fp - fi;

