function Y = fht2d(X)
%
% Fast Hartley Transform 2D
%
%  uses fht.m script file.
%
%  example
%  x=[3.64216,0.245849,0.545550,0.581559,2.70081,2.33060,1.88647,1.92779]  ;
%  x=x';
%  X=[x,x,x,x,x,x,x,x];
%  fht2d(X)/sqrt(8);
%ans =     4.9005   -1.1836    1.4065    0.1338    1.3043    0.9011    1.3590    1.4800

n = length(X); 
Y = zeros(n,n);

for i=1:n 
  Y(i,:) = fht(X(i,:)')'; 
end;

for j=1:n 
  Y(:,j) = fht(X(:,j)); 
end;

