function [sum] = c1(y)
%returns interpolation of value using Lagranian polynomial of degree N.
%
%  algorithm for interpolation  with a Lagrangian polynomial of degree N.
%
%  To interpolate for f(y), given y and a set of N+1 data pairs,
%    (x(i),f(i)), i=0,..,N:
%
%  Gerald-Wheatley pg. 216-217.
%
%  USAGE [sum] = c1(y)
%
      if (nargin==0),
        help c1; return
      end

      n = 4 ;
      x = [ 10.1     22.2     32.0     41.6     50.5    ];
      f = [  0.17537  0.37784  0.52992  0.66393  0.63608]; 
%
      sum = 0.0;     % interpolated value
%
      for i=0:n;

        p = 1.0;

        for j=0:n; 
          if ~(j == i ) 
            p = p*(y-x(j+1))/(x(i+1)-x(j+1)); 
          end;

        end;
      
        sum = sum + p*f(i+1);

      end;
% 
