%
% Neville's Method
% Evaluate the interpolating polynomial P(XX) for
% for a function f, given as (n + 1) ordered pairs {x(1), p(1, 1)}, ..., 
% {x(n + 1), p(n + 1, 1)}, 
% with x consisting of n + 1 distinct values;
%
% The value of P(XX) is p(n + 1, n + 1).

      disp(['Neville method']);
 
      n = 4; 

      x = [33.4 23.5 42.7 10.2 54.1];
      xx = 29.0;

      p = zeros(n+1,n+1);
      p(:,1) = [0.83485 0.91706 0.73491 0.98419 0.58637]';

      for i=1:n
        for j=1:i
          p(i+1,j+1)=((xx-x(i+1))*p(i,j)-(xx-x(i-j+1))*p(i+1,j))/(x(i-j+1)-x(i+1));
        end
      end

      for i=1:n+1
        disp([p(i,:)]);
      end
