module steff_module

implicit none

private

public :: steff

intrinsic abs

contains

      subroutine steff(g,y,xtol,ntol,iflag)
      real   , intent(inout)    :: y 
      real   , intent(in)       :: xtol
      integer, intent(in)       :: ntol
      integer, intent(inout)    :: iflag
!
      interface
        function g(y) result(g_result)  
          real , intent(in) :: y 
          real              :: g_result
        end function g 
      end interface
!
!
      integer :: n
      real    :: xi
      real    :: d
      real    :: delxi
      real    :: prevri
      real    :: rinv
!
!
      iflag = 0
      xi    = g(y)
      d     = xi-y
      rinv  = 0.0
!
      do 20 n=1,ntol
!
!***********************************************************************
! temporary print out
!***********************************************************************
!
        write(unit=6,fmt="(i4,2e15.7)") n,y,xi
!
        y     = g(xi)
        delxi = y-xi
!
!***********************************************************************
!  check for suffiently small change
!***********************************************************************
!
        if(abs(delxi) <= xtol	)then
          return
        endif
!
        prevri = rinv
        rinv   = d/delxi
!
!***********************************************************************
!  temporary printout
!***********************************************************************
!
        write(unit=6,fmt="(tr34,e15.7, e20.5)") y,rinv
!
!***********************************************************************
!  check whether current ratio indicates at least that abs(gprime(x))<1
!***********************************************************************
!
        if (abs(rinv)<=1) then
          go to 19
        endif
!
!***********************************************************************
!  check for approximately constant ratios
!***********************************************************************
!
        if (abs((rinv-prevri)/rinv) >= 1) then
          go to 19	
        endif
!
        y = y+delxi/(rinv-1.0)
!
        xi = g(y)
        d  = xi-y
!
        go to 20
!
 19	xi = y
        d  = delxi
!
 20     continue
!
        iflag=3
!
        write (unit=6,fmt="('error requirement not satisfied after ',i4,' iterations')") ntol
 
   endsubroutine steff 
!
end module steff_module

