      program ht2d 
      use ht_module, only : ht
!
!***********************************************************************
!  driver program for ht.
!
!
! compile
!
!f90 -c  ht.f90
!f90 -o ht2d.x ht.o ht2d.f90
!f90 -o ht2d.x  ht2d.o ht.o 
!
!run
! ht2d.x
!***********************************************************************
!

      implicit none
!
      integer, parameter :: n = 8 
      integer            :: i
!
      real, dimension(n) :: x      !input data
      real, dimension(n) :: y      !transformed data (hartley coeffs)
      real, dimension(n) :: z      !original data transformed from hartley coeffs. 
!
      print *
      print *
      print *, "Hartley Transform 2D"
      print *
!
!*******************************************************************************
!  define input values.
!*******************************************************************************
!
      x = (/          &
            3.64216 , &
            0.245849, &
            0.545550, &
            0.581559, &
            2.70081 , &
            2.33060 , &
            1.88647 , &
            1.92779   &
           /)
!
!*******************************************************************************
!  apply the transform (compute the coefficients).
!*******************************************************************************
!
      call ht(n,x,y)
!
!*******************************************************************************
!  inverse transform of coefficients to get back input data.
!*******************************************************************************
!
      call ht(n,y,z)

      print *,"   n        input          hartleycoeff     inv(hartleycoeff)"
      print *,"-------------------------------------------------------------"

      do i=1,n 
        print "(i5,3(tr2,f14.6))",i,x(i),y(i),z(i)
      end do

      print *
      print *

      endprogram ht2d 

