module intromx_module

use romb_module, only : romb
use f1_module, only  : f      !tbl42a
!use f2_module, only  : f     !tbl42b

implicit none

private

public :: intromx

integer, private, parameter :: real8 = selected_real_kind(10)

contains
 
      subroutine intromx(mmax, kol,a,b) 
      integer, intent(in) :: mmax
      integer, intent(in) :: kol
      real   , intent(in) :: a 
      real   , intent(in) :: b 
 
      real(kind=real8), dimension(0:50,0:50) :: al
      real(kind=real8), dimension(0:50)      :: c

      real                                   :: term

      integer                       :: j 
      integer                       :: k
      integer                       :: kk
      integer                       :: m
      integer                       :: ma
      integer                       :: mmaxplus
      integer                       :: iwotpr
      integer                       :: iwotmin

      mmaxplus = mmax + 1 
!
      al(0,0)=0.0

      do m=0, mmax 
        call romb(a,b,m, term,f) 
        al(m+1,0)=al(m,0)+term 
      enddo

      iwotpr = 1 

      do k=1, mmaxplus 
        iwotpr  = 2*iwotpr 
        iwotmin = iwotpr-1
        kk      = mmaxplus-k 
!
        do m=0, kk 
          al(m,k)=(iwotpr*al(m+1,k-1)-al(m,k-1))/iwotmin
        enddo
      enddo
!
      do kk=0, mmaxplus, kol 
        do m=0, mmaxplus-kk 
          ma = 0
          do k=kk,kk+kol-1 
            if (m <= mmaxplus-k) then
              ma    = ma+1
              c(ma) = al(m,k) 
            endif
          enddo
          print "(i5,10(tr2,f8.6))", m,(c(j), j=1,ma) 
        enddo
      enddo
!
      endsubroutine intromx
!
!***********************************************************************
!
end module intromx_module
!
