      program intrpol
!
!***********************************************************************
!  algorithm for interpolation  with a Lagrangian polynomial of degree N.
!
!  To interpolate for f(y), given y and a set of N+1 data pairs,
!    (x(i),f(i)), i=0,..,N:
!
!  reference: Gerald-Wheatley pg. 216-217.
!***********************************************************************
!
      implicit none
!
      integer,               parameter :: n = 4 
      real   , dimension(5), parameter :: x = (/ 10.1    , 22.2    , 32.0    , 41.6    , 50.5     /)
      real   , dimension(5), parameter :: f = (/  0.17537,  0.37784,  0.52992,  0.66393,  0.63608 /)

      integer                          :: i
      integer                          :: j
!
      real                             :: asum     ! interpolated value
      real                             :: p 
      real                             :: y 
!
!
      print *
      print *
      print *,"intrpol"
      print *
      print *, "input y"
!
      read(unit=*,fmt=*) y 
!
      asum =0.0 
!
      do i=0,n
        p = 1.0
        
        do j=0,n
          if (j /= i) then
            p = p*(y-x(j))/(x(i)-x(j))
            print "(2i4,tr5,f8.6)",i,j,p
          endif
        enddo
      
        asum = asum + p*f(i)

      enddo 
 
      print *," sum = ",asum
      
      endprogram intrpol
! 
