      program neville
!
!***********************************************************************
!       neville's method 
!
!     Evaluate the interpolating polynomial p(x) for a function f,
!     given as (n+1) ordered pairs {x(0),p(0,0)},...,{x(n+1),p(n+1)},
!     with x consisting of n+1 distince values.
!***********************************************************************
!
      integer, parameter          :: n = 4
!
      real   , dimension(n+1)     :: x
      real   , dimension(n+1,n+1) :: p 
      real                        :: XX
      integer                     :: i,j
!
      print * 
      print * 
      print *,"Neville's method"
      print * 

      x      = (/ 33.4, 23.5, 42.7, 10.2, 54.1 /)
      p      = 0.0
      p(:,1) = (/ 0.83485, 0.91706, 0.73491, 0.98419, 0.58637 /)
      XX     = 29.0
!
      do i=0,n
        do j=1,i
          p(i+1,j+1) = ((XX-x(i+1))*p(i,j)-(xx-x(i-j+1))*p(i+1,j))/(x(i-j+1)-x(i+1))
        enddo
      enddo

      do i=1,n+1
        print *,i,p(i,:)
      enddo

      print *
      endprogram neville

