      program xfht
      use hartley2d_module, only : hartley2d
!
!***********************************************************************
! compile
!
!  f90 -c  ./hartley2d.f90
!  f90 -c  xfht.f90
!  f90 -o xfht.x  xfht.o hartley2d.o 
!
! run
!  xfht.x
!***********************************************************************
!

      implicit none

      integer, parameter      :: n = 8 

      integer                 :: i 
      real   , dimension(n)   :: m1
      real   , dimension(n,n) :: m
!
!
      print *
      print *
      print *, "xfht"
      print *, "driver for hartley2d"
      print *, "n =",n
      print *

      m1 = (/          &
             3.64216  ,&
             0.245849 ,&
             0.545550 ,&
             0.581559 ,&
             2.70081  ,&
             2.33060  ,&
             1.88647  ,&
             1.92779   &
        /)
!
!***********************************************************************
!  replicate m1 in each column
!***********************************************************************
!
       m = spread(m1,dim=2,ncopies=n-1)

!  The Hartley coeffs:
! 
!{4.90053,-1.18365,1.40645,0.133791,1.30433,0.901101,1.35901,1.48002}

      call hartley2d(n,m)    

      print *,"  n     input       hartleycoeffs"
      print *,"---------------------------------"
      do i=1,n
        print "(i4,2(tr2,f10.5))",i,m1(i),sqrt(real(n))*m(i,1)/(n*n)
      enddo
  
      print *
      print *
     
      endprogram xfht

